# Copyright (c) 2016-2017 Anki, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License in the file LICENSE.txt or at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

"""
Autogenerated python message buffer code.
Source: clad/types/animationTrigger.clad
Full command line: ../tools/message-buffers/emitters/Python_emitter.py -C ./src/ -I ../robot/clad/src/ ../coretech/vision/clad/src/ ../coretech/common/clad/src/ ../lib/util/source/anki/clad -o ../generated/cladPython// clad/types/animationTrigger.clad
"""

from __future__ import absolute_import
from __future__ import print_function

def _modify_path():
  import inspect, os, sys
  search_paths = [
    '../..',
    '../../../../tools/message-buffers/support/python',
  ]
  currentpath = os.path.abspath(os.path.dirname(inspect.getfile(inspect.currentframe())))
  for search_path in search_paths:
    search_path = os.path.normpath(os.path.abspath(os.path.realpath(os.path.join(currentpath, search_path))))
    if search_path not in sys.path:
      sys.path.insert(0, search_path)
_modify_path()

import msgbuffers

Anki = msgbuffers.Namespace()
Anki.Cozmo = msgbuffers.Namespace()

class AnimationTrigger(object):
  "Automatically-generated int_32 enumeration."
  AcknowledgeFaceInitPause                = 0
  AcknowledgeFaceNamed                    = 1
  AcknowledgeFaceUnnamed                  = 2
  AcknowledgeObject                       = 3
  AskToBeRightedLeft                      = 4
  AskToBeRightedRight                     = 5
  AudioTestAnim                           = 6
  BlockReact                              = 7
  BouncerGetIn                            = 8
  BouncerGetOut                           = 9
  BouncerIdeaToPlay                       = 10
  BouncerIntoScore1                       = 11
  BouncerIntoScore2                       = 12
  BouncerIntoScore3                       = 13
  BouncerRequestToPlay                    = 14
  BouncerTimeout                          = 15
  BouncerWait                             = 16
  BuildPyramidFirstBlockOnSide            = 17
  BuildPyramidFirstBlockUpright           = 18
  BuildPyramidLookForFace                 = 19
  BuildPyramidReactToBase                 = 20
  BuildPyramidSecondBlockOnSide           = 21
  BuildPyramidSecondBlockUpright          = 22
  BuildPyramidSuccess                     = 23
  BuildPyramidThankUser                   = 24
  BuildPyramidThirdBlockOnSide            = 25
  BuildPyramidThirdBlockUpright           = 26
  CantHandleTallStack                     = 27
  PatternGuessNewIdea                     = 28
  PatternGuessThinking                    = 29
  CodeLab123Go                            = 30
  CodeLabAmazed                           = 31
  CodeLabBored                            = 32
  CodeLabCat                              = 33
  CodeLabCelebrate                        = 34
  CodeLabChatty                           = 35
  CodeLabConducting                       = 36
  CodeLabCurious                          = 37
  CodeLabDancingMambo                     = 38
  CodeLabDejected                         = 39
  CodeLabDizzy                            = 40
  CodeLabDizzyEnd                         = 41
  CodeLabDog                              = 42
  CodeLabEnter                            = 43
  CodeLabExcited                          = 44
  CodeLabExit                             = 45
  CodeLabFireTruck                        = 46
  CodeLabFrustrated                       = 47
  CodeLabGetInPos                         = 48
  CodeLabHappy                            = 49
  CodeLabIDK                              = 50
  CodeLabIdle                             = 51
  CodeLabLose                             = 52
  CodeLabNo                               = 53
  CodeLabPartyTime                        = 54
  CodeLabReactHappy                       = 55
  CodeLabSleep                            = 56
  CodeLabSneeze                           = 57
  CodeLabSurprise                         = 58
  CodeLabTakaTaka                         = 59
  CodeLabTapCube                          = 60
  CodeLabThinking                         = 61
  CodeLabUnhappy                          = 62
  CodeLabVictory                          = 63
  CodeLabWin                              = 64
  CodeLabYes                              = 65
  ConnectWakeUp                           = 66
  ConnectWakeUp_SevereEnergy              = 67
  ConnectWakeUp_SevereRepair              = 68
  ComeHere_AlreadyHere                    = 69
  ComeHere_SearchForFace                  = 70
  ComeHere_SearchForFace_FoundFace        = 71
  CozmoSaysGetIn                          = 72
  CozmoSaysGetOut                         = 73
  CozmoSaysSpeakGetInShort                = 74
  CozmoSaysSpeakGetInMedium               = 75
  CozmoSaysSpeakGetInLong                 = 76
  CozmoSaysSpeakGetOutShort               = 77
  CozmoSaysSpeakGetOutMedium              = 78
  CozmoSaysSpeakGetOutLong                = 79
  CozmoSaysSpeakLoop                      = 80
  CozmoSaysBadWord                        = 81
  CozmoSaysIdle                           = 82
  CubeMovedSense                          = 83
  CubeMovedUpset                          = 84
  CubePounceFake                          = 85
  CubePounceGetIn                         = 86
  CubePounceGetOut                        = 87
  CubePounceGetReady                      = 88
  CubePounceGetUnready                    = 89
  CubePounceIdleLiftDown                  = 90
  CubePounceIdleLiftUp                    = 91
  CubePounceLoseHand                      = 92
  CubePounceLoseRound                     = 93
  CubePounceLoseSession                   = 94
  CubePouncePounceClose                   = 95
  CubePouncePounceNormal                  = 96
  CubePounceWinHand                       = 97
  CubePounceWinRound                      = 98
  CubePounceWinSession                    = 99
  DanceMambo                              = 100
  DemoSpeedTapCozmoWin                    = 101
  DemoSpeedTapCozmoLose                   = 102
  DizzyReactionHard                       = 103
  DizzyReactionMedium                     = 104
  DizzyReactionSoft                       = 105
  DizzyShakeLoop                          = 106
  DizzyShakeStop                          = 107
  DizzyStillPickedUp                      = 108
  DriveEndAngry                           = 109
  DriveEndDefault                         = 110
  DriveEndHappy                           = 111
  DriveEndLaunch                          = 112
  DriveLoopAngry                          = 113
  DriveLoopDefault                        = 114
  DriveLoopHappy                          = 115
  DriveLoopLaunch                         = 116
  DriveStartAngry                         = 117
  DriveStartDefault                       = 118
  DriveStartHappy                         = 119
  DriveStartLaunch                        = 120
  DroneModeBackwardDrivingEnd             = 121
  DroneModeBackwardDrivingLoop            = 122
  DroneModeBackwardDrivingStart           = 123
  DroneModeCliffEvent                     = 124
  DroneModeForwardDrivingEnd              = 125
  DroneModeForwardDrivingLoop             = 126
  DroneModeForwardDrivingStart            = 127
  DroneModeGetIn                          = 128
  DroneModeGetOut                         = 129
  DroneModeIdle                           = 130
  DroneModeKeepAlive                      = 131
  DroneModeTurboDrivingStart              = 132
  EarnedSparks                            = 133
  FacePlantRoll                           = 134
  FacePlantRollArmUp                      = 135
  FailedToRightFromFace                   = 136
  FeedingAteFullEnough_Normal             = 137
  FeedingAteFullEnough_Severe             = 138
  FeedingAteNotFullEnough_Normal          = 139
  FeedingAteNotFullEnough_Severe          = 140
  FeedingDrivingGetIn_Severe              = 141
  FeedingDrivingGetOut_Severe             = 142
  FeedingDrivingLoop_Severe               = 143
  FeedingPlaceLiftOnCube_Normal           = 144
  FeedingPlaceLiftOnCube_Severe           = 145
  FeedingIdleSearch_Normal                = 146
  FeedingIdleSearch_Severe                = 147
  FeedingIdleSearchForFaces_Normal        = 148
  FeedingIdleSearchForFaces_Severe        = 149
  FeedingIdleWaitForFullCube_Normal       = 150
  FeedingIdleWaitForFullCube_Severe       = 151
  FeedingIdleWaitForShakeNoHead_Severe    = 152
  FeedingIdleWaitForShake_Normal          = 153
  FeedingIdleWaitForShake_Severe          = 154
  FeedingInterrupted                      = 155
  FeedingInterrupted_Severe               = 156
  FeedingSearchRequest                    = 157
  FeedingSearchRequest_Severe             = 158
  FeedingSearchFailure                    = 159
  FeedingSearchFailure_Severe             = 160
  FeedingReactToFullCube_Normal           = 161
  FeedingReactToFullCube_Severe           = 162
  FeedingReactToSeeCube_Normal            = 163
  FeedingReactToSeeCube_Severe            = 164
  FeedingReactToShake_Normal              = 165
  FeedingReactToShake_Severe              = 166
  FistBumpIdle                            = 167
  FistBumpRequestOnce                     = 168
  FistBumpRequestRetry                    = 169
  FistBumpSuccess                         = 170
  FistBumpLeftHanging                     = 171
  FlipDownFromBack                        = 172
  FrustratedByFailure                     = 173
  FrustratedByFailureMajor                = 174
  GameSetupGetIn                          = 175
  GameSetupGetOut                         = 176
  GameSetupIdle                           = 177
  GameSetupReaction                       = 178
  GoToSleepGetIn                          = 179
  GoToSleepGetOut                         = 180
  GoToSleepOff                            = 181
  GoToSleepSleeping                       = 182
  GuardDogBusted                          = 183
  GuardDogCubeDisconnect                  = 184
  GuardDogFakeout                         = 185
  GuardDogInterruption                    = 186
  GuardDogPlayerSuccess                   = 187
  GuardDogPulse                           = 188
  GuardDogSettle                          = 189
  GuardDogSleepLoop                       = 190
  GuardDogTimeout                         = 191
  GuardDogTimeoutCubesTouched             = 192
  GuardDogTimeoutCubesUntouched           = 193
  Hiccup                                  = 194
  HiccupGetIn                             = 195
  HiccupPlayerCure                        = 196
  HiccupRobotOnBack                       = 197
  HiccupRobotOnFace                       = 198
  HiccupRobotPickedUp                     = 199
  HiccupSelfCure                          = 200
  HikingDrivingEnd                        = 201
  HikingDrivingLoop                       = 202
  HikingDrivingStart                      = 203
  HikingInterestingEdgeThought            = 204
  HikingIntro                             = 205
  HikingLookAround                        = 206
  HikingObserve                           = 207
  HikingReactToEdge                       = 208
  HikingReactToNewArea                    = 209
  HikingReactToPossibleMarker             = 210
  HikingSquintEnd                         = 211
  HikingSquintLoop                        = 212
  HikingSquintStart                       = 213
  HikingWakeUpOffCharger                  = 214
  IdleOnCharger                           = 215
  InteractWithFaceTrackingIdle            = 216
  InteractWithFacesInitialNamed           = 217
  InteractWithFacesInitialUnnamed         = 218
  KnockOverEyes                           = 219
  KnockOverFailure                        = 220
  KnockOverGrabAttempt                    = 221
  KnockOverPreActionNamedFace             = 222
  KnockOverPreActionUnnamedFace           = 223
  KnockOverSuccess                        = 224
  LaserAcknowledge                        = 225
  LaserDriveEnd                           = 226
  LaserDriveLoop                          = 227
  LaserDriveStart                         = 228
  LaserFace                               = 229
  LaserGetOut                             = 230
  LaserPounce                             = 231
  LookInPlaceForFacesBodyPause            = 232
  LookInPlaceForFacesHeadMovePause        = 233
  MajorFail                               = 234
  MajorWin                                = 235
  MeetCozmoGetIn                          = 236
  MeetCozmoLookFaceGetIn                  = 237
  MeetCozmoLookFaceGetOut                 = 238
  MeetCozmoScanningIdle                   = 239
  MeetCozmoFirstEnrollmentSayName         = 240
  MeetCozmoFirstEnrollmentRepeatName      = 241
  MeetCozmoFirstEnrollmentCelebration     = 242
  MeetCozmoReEnrollmentSayName            = 243
  MeetCozmoRenameFaceSayName              = 244
  MeetCozmoLookFaceInterrupt              = 245
  MemoryMatchPlayerWinHand                = 246
  MemoryMatchPlayerWinHandLong            = 247
  MemoryMatchPlayerWinHandSolo            = 248
  MemoryMatchPlayerLoseHand               = 249
  MemoryMatchPlayerLoseHandSolo           = 250
  MemoryMatchCozmoWinHand                 = 251
  MemoryMatchCozmoLoseHand                = 252
  MemoryMatchCozmoWinGame                 = 253
  MemoryMatchPlayerWinGame                = 254
  MemoryMatchSoloGameOver                 = 255
  MemoryMatchReactToPattern               = 256
  MemoryMatchReactToPatternSolo           = 257
  MemoryMatchPointCenter                  = 258
  MemoryMatchPointLeftBig                 = 259
  MemoryMatchPointLeftSmall               = 260
  MemoryMatchPointRightBig                = 261
  MemoryMatchPointRightSmall              = 262
  MemoryMatchPointCenterFast              = 263
  MemoryMatchPointLeftBigFast             = 264
  MemoryMatchPointLeftSmallFast           = 265
  MemoryMatchPointRightBigFast            = 266
  MemoryMatchPointRightSmallFast          = 267
  MemoryMatchCozmoGetOut                  = 268
  MemoryMatchCozmoFollowTapsSoundOnly     = 269
  NamedFaceInitialGreeting                = 270
  NeedsMildLowEnergyRequest               = 271
  NeedsMildLowPlayRequest                 = 272
  NeedsMildLowRepairRequest               = 273
  NeedsSevereLowEnergyCliffReact          = 274
  NeedsSevereLowEnergyDrivingEnd          = 275
  NeedsSevereLowEnergyDrivingLoop         = 276
  NeedsSevereLowEnergyDrivingStart        = 277
  NeedsSevereLowEnergyForceGetOut         = 278
  NeedsSevereLowEnergyGetIn               = 279
  NeedsSevereLowEnergyIdle                = 280
  NeedsSevereLowEnergyRequest             = 281
  NeedsSevereLowEnergySlopeReact          = 282
  NeedsSevereLowPlayForceGetOut           = 283
  NeedsSevereLowPlayGetIn                 = 284
  NeedsSevereLowPlayRequest               = 285
  NeedsSevereLowRepairCliffReact          = 286
  NeedsSevereLowRepairDrivingEnd          = 287
  NeedsSevereLowRepairDrivingLoop         = 288
  NeedsSevereLowRepairDrivingStart        = 289
  NeedsSevereLowRepairForceGetOut         = 290
  NeedsSevereLowRepairGetIn               = 291
  NeedsSevereLowRepairIdle                = 292
  NeedsSevereLowRepairRequest             = 293
  NeedsSevereLowRepairSlopeReact          = 294
  NeutralFace                             = 295
  NothingToDoBoredEvent                   = 296
  NothingToDoBoredIdle                    = 297
  NothingToDoBoredIntro                   = 298
  NothingToDoBoredOutro                   = 299
  OnLearnedPlayerName                     = 300
  OnSawNewNamedFace                       = 301
  OnSawNewUnnamedFace                     = 302
  OnSawOldNamedFace                       = 303
  OnSawOldUnnamedFace                     = 304
  OnSpeedtapCozmoConfirm                  = 305
  OnSpeedtapFakeout                       = 306
  OnSpeedtapGameCozmoWinHighIntensity     = 307
  OnSpeedtapGameCozmoWinLowIntensity      = 308
  OnSpeedtapGamePlayerWinHighIntensity    = 309
  OnSpeedtapGamePlayerWinLowIntensity     = 310
  OnSpeedtapGetOut                        = 311
  OnSpeedtapHandCozmoWin                  = 312
  OnSpeedtapHandPlayerWin                 = 313
  OnSpeedtapIdle                          = 314
  OnSpeedtapRoundCozmoWinHighIntensity    = 315
  OnSpeedtapRoundCozmoWinLowIntensity     = 316
  OnSpeedtapRoundPlayerWinHighIntensity   = 317
  OnSpeedtapRoundPlayerWinLowIntensity    = 318
  OnSpeedtapTap                           = 319
  OnWaitForCubesMinigameSetup             = 320
  OnWiggle                                = 321
  OnboardingBirth                         = 322
  OnboardingCubeDockFail                  = 323
  OnboardingDiscoverCube                  = 324
  OnboardingDriveEnd                      = 325
  OnboardingDriveLoop                     = 326
  OnboardingDriveStart                    = 327
  OnboardingEyesOn                        = 328
  OnboardingHelloPlayer                   = 329
  OnboardingHelloWorld                    = 330
  OnboardingIdle                          = 331
  OnboardingIdleEnergy                    = 332
  OnboardingIdlePlay                      = 333
  OnboardingIdleRepair                    = 334
  OnboardingInteractWithCube              = 335
  OnboardingPreBirth                      = 336
  OnboardingReactToCube                   = 337
  OnboardingReactToCubePutDown            = 338
  OnboardingReactToFace                   = 339
  OnboardingSoundOnlyLiftEffortPickup     = 340
  OnboardingSoundOnlyLiftEffortPlaceLow   = 341
  OnboardingGetOut                        = 342
  OnboardingWakeUpDriveOffCharger         = 343
  PeekABooGetIn                           = 344
  PeekABooGetOutHappy                     = 345
  PeekABooGetOutSad                       = 346
  PeekABooHighIntensity                   = 347
  PeekABooIdle                            = 348
  PeekABooLowIntensity                    = 349
  PeekABooMedIntensity                    = 350
  PeekABooNoUserInteraction               = 351
  PeekABooShort                           = 352
  PeekABooSurprised                       = 353
  PetDetectionCat                         = 354
  PetDetectionDog                         = 355
  PetDetectionShort                       = 356
  PetDetectionShort_Cat                   = 357
  PetDetectionShort_Dog                   = 358
  PetDetectionSneeze                      = 359
  PickupHelperPreActionNamedFace          = 360
  PickupHelperPreActionUnnamedFace        = 361
  PlacedOnCharger                         = 362
  PopAWheelieInitial                      = 363
  PopAWheeliePreActionNamedFace           = 364
  PopAWheeliePreActionUnnamedFace         = 365
  PopAWheelieRealign                      = 366
  PopAWheelieRetry                        = 367
  PounceDriveEnd                          = 368
  PounceDriveLoop                         = 369
  PounceDriveStart                        = 370
  PounceFace                              = 371
  PounceFail                              = 372
  PounceGetOut                            = 373
  PounceInitial                           = 374
  PouncePounce                            = 375
  PounceSuccess                           = 376
  ProceduralLive                          = 377
  PutDownBlockKeepAlive                   = 378
  PutDownBlockPutDown                     = 379
  ReactToBlockPickupSuccess               = 380
  ReactToBlockRetryPickup                 = 381
  ReactToCliff                            = 382
  ReactToCliffDetectorStop                = 383
  ReactToFalling                          = 384
  ReactToImpact                           = 385
  ReactToObstacle                         = 386
  ReactToMotorCalibration                 = 387
  ReactToNewBlockAsk                      = 388
  ReactToNewBlockBig                      = 389
  ReactToNewBlockSmall                    = 390
  ReactToOnLeftSide                       = 391
  ReactToOnRightSide                      = 392
  ReactToPerchedOnBlock                   = 393
  ReactToPickup                           = 394
  ReactToPokeReaction                     = 395
  ReactToPokeStartled                     = 396
  ReactToUnexpectedMovement               = 397
  ReactToUnexpectedMovement_Severe_Energy = 398
  ReactToUnexpectedMovement_Severe_Repair = 399
  RepairFailMild                          = 400
  RepairFailSevere                        = 401
  RepairFixMildGetIn                      = 402
  RepairFixMildGetOut                     = 403
  RepairFixMildGetReady                   = 404
  RepairFixMildHeadDown                   = 405
  RepairFixMildHeadUp                     = 406
  RepairFixMildIdle                       = 407
  RepairFixMildLiftDown                   = 408
  RepairFixMildLiftUp                     = 409
  RepairFixMildLowerLift                  = 410
  RepairFixMildRaiseLift                  = 411
  RepairFixMildRoundReact                 = 412
  RepairFixMildWheelsBack                 = 413
  RepairFixMildWheelsForward              = 414
  RepairFixSevereGetIn                    = 415
  RepairFixSevereGetOut                   = 416
  RepairFixSevereGetReady                 = 417
  RepairFixSevereHeadDown                 = 418
  RepairFixSevereHeadUp                   = 419
  RepairFixSevereIdle                     = 420
  RepairFixSevereLiftDown                 = 421
  RepairFixSevereLiftUp                   = 422
  RepairFixSevereLowerLift                = 423
  RepairFixSevereRaiseLift                = 424
  RepairFixSevereRoundReact               = 425
  RepairFixSevereWheelsBack               = 426
  RepairFixSevereWheelsForward            = 427
  RepairIdleFullyRepaired                 = 428
  RepairPartRepaired_Head_Mild            = 429
  RepairPartRepaired_Lift_Mild            = 430
  RepairPartRepaired_Tread_Mild           = 431
  RequestGameInterrupt                    = 432
  RequestGameKeepAwayAccept0              = 433
  RequestGameKeepAwayAccept1              = 434
  RequestGameKeepAwayDeny0                = 435
  RequestGameKeepAwayDeny1                = 436
  RequestGameKeepAwayIdle0                = 437
  RequestGameKeepAwayIdle1                = 438
  RequestGameKeepAwayInitial0             = 439
  RequestGameKeepAwayInitial1             = 440
  RequestGameKeepAwayPreDrive0            = 441
  RequestGameKeepAwayPreDrive1            = 442
  RequestGameKeepAwayRequest0             = 443
  RequestGameKeepAwayRequest1             = 444
  RequestGameMemoryMatchAccept0           = 445
  RequestGameMemoryMatchAccept1           = 446
  RequestGameMemoryMatchDeny0             = 447
  RequestGameMemoryMatchDeny1             = 448
  RequestGameMemoryMatchIdle0             = 449
  RequestGameMemoryMatchIdle1             = 450
  RequestGameMemoryMatchInitial0          = 451
  RequestGameMemoryMatchInitial1          = 452
  RequestGameMemoryMatchPreDrive0         = 453
  RequestGameMemoryMatchPreDrive1         = 454
  RequestGameMemoryMatchRequest0          = 455
  RequestGameMemoryMatchRequest1          = 456
  RequestGamePickupFail                   = 457
  RequestGameSpeedTapAccept0              = 458
  RequestGameSpeedTapAccept1              = 459
  RequestGameSpeedTapDeny0                = 460
  RequestGameSpeedTapDeny1                = 461
  RequestGameSpeedTapIdle0                = 462
  RequestGameSpeedTapIdle1                = 463
  RequestGameSpeedTapInitial0             = 464
  RequestGameSpeedTapInitial1             = 465
  RequestGameSpeedTapPreDrive0            = 466
  RequestGameSpeedTapPreDrive1            = 467
  RequestGameSpeedTapRequest0             = 468
  RequestGameSpeedTapRequest1             = 469
  RollBlockInitial                        = 470
  RollBlockPreActionNamedFace             = 471
  RollBlockPreActionUnnamedFace           = 472
  RollBlockPutDown                        = 473
  RollBlockRealign                        = 474
  RollBlockRetry                          = 475
  RollBlockSuccess                        = 476
  SdkTextToSpeech                         = 477
  Shiver                                  = 478
  Shocked                                 = 479
  Singing_80bpm                           = 480
  Singing_100bpm                          = 481
  Singing_120bpm                          = 482
  Singing_GetIn                           = 483
  Singing_GetOut                          = 484
  Sleeping                                = 485
  SoftSparkUpgradeLift                    = 486
  SoftSparkUpgradeTracks                  = 487
  SoundOnlyLiftEffortPickup               = 488
  SoundOnlyLiftEffortPlaceHigh            = 489
  SoundOnlyLiftEffortPlaceLow             = 490
  SoundOnlyLiftEffortPlaceRoll            = 491
  SoundOnlyRamIntoBlock                   = 492
  SoundOnlyTurnSmall                      = 493
  SparkDrivingLoop                        = 494
  SparkDrivingStart                       = 495
  SparkDrivingStop                        = 496
  SparkFailure                            = 497
  SparkGetIn                              = 498
  SparkGetOut                             = 499
  SparkIdle                               = 500
  SparkPickupFinalCubeReaction            = 501
  SparkPickupInitialCubeReaction          = 502
  SparkSuccess                            = 503
  SpeedTapDrivingEnd                      = 504
  SpeedTapDrivingLoop                     = 505
  SpeedTapDrivingStart                    = 506
  StackBlocksSuccess                      = 507
  StartSleeping                           = 508
  SuccessfulWheelie                       = 509
  Surprise                                = 510
  TurtleRoll                              = 511
  UnitTestAnim                            = 512
  VC_Alrighty                             = 513
  VC_HowAreYouDoing_AllGood               = 514
  VC_Listening                            = 515
  VC_LookDownForLaser                     = 516
  VC_LookDownNoLaser                      = 517
  VC_NoFollowupCommand_NoFace             = 518
  VC_NoFollowupCommand_WithFace           = 519
  VC_Refuse_energy                        = 520
  VC_Refuse_repair                        = 521
  VC_Refuse_sparks                        = 522
  VC_StartledWakeup                       = 523
  WaitOnSideLoop                          = 524
  WorkoutPostLift_highEnergy              = 525
  WorkoutPostLift_lowEnergy               = 526
  WorkoutPostLift_mediumEnergy            = 527
  WorkoutPreLift_highEnergy               = 528
  WorkoutPreLift_lowEnergy                = 529
  WorkoutPreLift_mediumEnergy             = 530
  WorkoutPutDown_highEnergy               = 531
  WorkoutPutDown_lowEnergy                = 532
  WorkoutPutDown_lowEnergy_simple         = 533
  WorkoutPutDown_mediumEnergy             = 534
  WorkoutStrongLift_highEnergy            = 535
  WorkoutStrongLift_lowEnergy             = 536
  WorkoutStrongLift_mediumEnergy          = 537
  WorkoutTransition_highEnergy            = 538
  WorkoutTransition_lowEnergy             = 539
  WorkoutTransition_mediumEnergy          = 540
  WorkoutWeakLift_highEnergy              = 541
  WorkoutWeakLift_lowEnergy               = 542
  WorkoutWeakLift_mediumEnergy            = 543
  Count                                   = 544

Anki.Cozmo.AnimationTrigger = AnimationTrigger
del AnimationTrigger


class CubeAnimationTrigger(object):
  "Automatically-generated int_32 enumeration."
  Carrying                    = 0
  Connected                   = 1
  CubePouncePlayerLose        = 2
  CubePouncePlayerWin         = 3
  Dance_01                    = 4
  Dance_02                    = 5
  Dance_03                    = 6
  Dance_04                    = 7
  Dance_05                    = 8
  Dance_06                    = 9
  DanceFadeOff                = 10
  DrivingTo                   = 11
  FeedingBlank                = 12
  FeedingCyanCycle            = 13
  FeedingCyanSolid            = 14
  Flash                       = 15
  GatherCubesAllCubesInBeacon = 16
  GatherCubesCubeInBeacon     = 17
  GuardDogBeingMoved          = 18
  GuardDogBusted              = 19
  GuardDogOff                 = 20
  GuardDogSetup               = 21
  GuardDogSleeping            = 22
  GuardDogSuccessfullyFlipped = 23
  Interacting                 = 24
  InteractingBehaviorLock     = 25
  Onboarding                  = 26
  PyramidBaseBottom           = 27
  PyramidFlourish             = 28
  PyramidOnSideLocated        = 29
  PyramidOnSideNotLocated     = 30
  PyramidPickup               = 31
  PyramidSingle               = 32
  Sleep                       = 33
  SleepNoFade                 = 34
  SpeedTapWin                 = 35
  SpeedTapLose                = 36
  Visible                     = 37
  WakeUp                      = 38
  Workout                     = 39
  Count                       = 40

Anki.Cozmo.CubeAnimationTrigger = CubeAnimationTrigger
del CubeAnimationTrigger


