# Copyright (c) 2016-2017 Anki, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License in the file LICENSE.txt or at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

"""
Autogenerated python message buffer code.
Source: clad/types/behaviorSystem/behaviorObjectives.clad
Full command line: ../tools/message-buffers/emitters/Python_emitter.py -C ./src/ -I ../robot/clad/src/ ../coretech/vision/clad/src/ ../coretech/common/clad/src/ ../lib/util/source/anki/clad -o ../generated/cladPython// clad/types/behaviorSystem/behaviorObjectives.clad
"""

from __future__ import absolute_import
from __future__ import print_function

def _modify_path():
  import inspect, os, sys
  search_paths = [
    '../../..',
    '../../../../../tools/message-buffers/support/python',
  ]
  currentpath = os.path.abspath(os.path.dirname(inspect.getfile(inspect.currentframe())))
  for search_path in search_paths:
    search_path = os.path.normpath(os.path.abspath(os.path.realpath(os.path.join(currentpath, search_path))))
    if search_path not in sys.path:
      sys.path.insert(0, search_path)
_modify_path()

import msgbuffers

Anki = msgbuffers.Namespace()
Anki.Cozmo = msgbuffers.Namespace()

class BehaviorObjective(object):
  "Automatically-generated int_32 enumeration."
  Unknown                      = 0
  AnimationPlayed              = 1
  BlockRolled                  = 2
  BuiltPyramid                 = 3
  DroveAsIntended              = 4
  EnrolledFaceWithName         = 5
  FistBumpComplete             = 6
  FistBumpSuccess              = 7
  FistBumpLeftHanging          = 8
  FoundFace                    = 9
  GatheredCubes                = 10
  InteractedWithFace           = 11
  KnockedOverBlocks            = 12
  LaserPounced                 = 13
  LaserTracked                 = 14
  PeekABooComplete             = 15
  PeekABooSuccess              = 16
  PerformedWorkout             = 17
  PerformedStrongWorkout       = 18
  PickedupBlock                = 19
  PickedUpAndPutDownBlock      = 20
  PoppedWheelie                = 21
  PouncedAndCaught             = 22
  PutDownBlock                 = 23
  ReactedAcknowledgedCubeMoved = 24
  ReactedAcknowledgedFace      = 25
  ReactedAcknowledgedObject    = 26
  ReactedToCliff               = 27
  ReactedToFrustration         = 28
  ReactedToOnCharger           = 29
  ReactedToPickup              = 30
  ReactedToPoke                = 31
  ReactedToRobotOnBack         = 32
  ReactedToRobotOnFace         = 33
  ReactedToRobotOnSide         = 34
  ReactedToRobotShaken         = 35
  ReactedToUnexpectedMovement  = 36
  RequestedGame                = 37
  Singing                      = 38
  StackedBlock                 = 39
  Count                        = 40

Anki.Cozmo.BehaviorObjective = BehaviorObjective
del BehaviorObjective


